//
//  ABOAssetSampleEnumerator.h
//  Magi
//
//  Created by Jamie Hardt on 7/4/12.
//  Copyright (c) 2012 Jamie Hardt. All rights reserved.
//

/*
 This file is part of Magi.
 
 Magi is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, version 2.0.
 
 Magi is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Magi.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>

@interface ABOAssetSampleEnumerator : NSObject {
    AVAsset         *_asset;
    AVAssetTrack    *_track;
    NSDictionary    *_settings;
    NSLock          *_readerLock;
    CMTimeRange     _timeRange;
}

-(id)initWithAsset:(AVAsset *)asset
             track:(AVAssetTrack *)track;

-(id)initWithAsset:(AVAsset *)asset
             track:(AVAssetTrack *)track
    outputSettings:(NSDictionary *)settings;

@property (assign) CMTimeRange timeRange;

-(void)enumerateSamplesWithBlock:(void(^)(CMSampleBufferRef buffer))sampleBlock 
                    errorHandler:(void(^)(NSError *error))errorBlock
    finishHandler:(void(^)(AVAssetReaderStatus status))finishBlock;


@end
