//
//  ABOComplexVector.h
//  Magi
//
//  Created by Jamie Hardt on 4/29/12.
//  Copyright (c) 2012 Jamie Hardt. All rights reserved.
//

/*
 This file is part of Magi.
 
 Magi is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, version 2.0.
 
 Magi is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Magi.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Foundation/Foundation.h>

#import <Cocoa/Cocoa.h>
#import <aubio/aubio.h>


@interface ABOComplexVector : NSObject {
    cvec_t *_priv;
}

-(id)initWithCvec:(cvec_t *)complexVector;

-(id)initWithLength:(uint_t)length
       channelCount:(uint_t)channels;

@property (readonly) uint_t length;
@property (readonly) uint_t channelCount;
@property (readonly) cvec_t *CVec;

-(void)setNorm:(smpl_t)normVal phase:(smpl_t)phaseVal
    atPosition:(uint_t)position inChannel:(uint_t)chan;

-(void)getNorm:(smpl_t *)normVal phase:(smpl_t *)phaseVal 
    atPosition:(uint_t)position inChannel:(uint_t)chan;


@end
