//
//  ABOOnsetDetector.h
//  Magi
//
//  Created by Jamie Hardt on 7/6/12.
//  Copyright (c) 2012 Jamie Hardt. All rights reserved.
//

/*
 This file is part of Magi.
 
 Magi is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, version 2.0.
 
 Magi is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Magi.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>
#import <aubio/aubio.h>

@interface ABOOnsetDetector : NSObject {
    AVAsset         *_asset;
    AVAssetTrack    *_track;
}

-(id)initWithAsset:(AVAsset *)asset 
             track:(AVAssetTrack *)track;

-(NSArray *)onsetsOfType:(aubio_onsetdetection_type)type 
               onChannel:(NSUInteger)channel
           withPeakThreshold:(smpl_t)threshold ;


@end
