//
//  ABOSampleVector+ArtihmeticAdditions.m
//  Magi
//
//  Created by Jamie Hardt on 7/8/12.
//  Copyright (c) 2012 Jamie Hardt. All rights reserved.
//

#import "ABOSampleVector+ArtihmeticAdditions.h"

@implementation ABOSampleVector (ArtihmeticAdditions)

-(smpl_t)peakAtFrame:(uint_t *)outIndex inChannel:(uint_t *)outChannel {
    
    smpl_t retVal = 0.0f, compVal = 0.0f;
    *outIndex = 0;
    *outChannel = 0;

    EACH_SAMPLE(
                compVal = [self sampleAtFrame:index inChannel:chan];
                if ( fabsf(compVal) > fabsf(retVal) ) {
                    retVal = compVal;
                    *outIndex = index;
                    *outChannel = chan;
                }
                );
            
    
    return retVal;
}

-(ABOSampleVector *)monoVector {
    ABOSampleVector *retObj = [[ABOSampleVector alloc] initWithLength:self.length 
                                                         channelCount:1];
    
    EACH_SAMPLE(
        [retObj FVec]->data[0][index] += [self FVec]->data[chan][index]
    );
    return retObj;
}


-(smpl_t)sum {
    smpl_t sum = 0.0f;
    
    EACH_SAMPLE( sum += [self sampleAtFrame:index inChannel:chan] );
    return sum;
}

-(smpl_t)rectifiedSum {
    smpl_t sum = 0.0f;
    
    EACH_SAMPLE( sum += fabsf([self sampleAtFrame:index inChannel:chan]) );
    return sum;
}

-(smpl_t)average {
    return [self sum] / (smpl_t)(self.length * self.channelCount);
}

-(smpl_t)rectifiedAverage {
    return [self rectifiedSum] / (smpl_t)(self.length * self.channelCount);
}


@end
