//
//  ABOTestSignalGenerator.h
//  Magi
//
//  Created by Jamie Hardt on 4/29/12.
//  Copyright (c) 2012 Jamie Hardt. All rights reserved.
//

/*
 This file is part of Magi.
 
 Magi is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, version 2.0.
 
 Magi is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Magi.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Foundation/Foundation.h>
#import <aubio/aubio.h>
#import "ABOSampleVector.h"

typedef enum _signals {
    ABOSignalTypeSineWave = 1001,
    ABOSignalTypeSquareWave,
    ABOSignalTypeDiracComb,
    ABOSignalTypeWhiteNoise
    } ABOSignalType;

@interface ABOTestSignalGenerator : NSObject {
    smpl_t  _peakGain;
    smpl_t  _dutyCycle;
    
    ABOSignalType _signalType;
}

+(id)testGenerator;

-(ABOSampleVector *)createTestSignalWithPeriods:(uint_t)length
                               samplesPerPeriod:(uint_t)samples;

@property (readwrite,nonatomic) smpl_t peakGain;
@property (readwrite,nonatomic) smpl_t dutyCycle;

@end
