//
//  ABOAssetSampleEnumerator_testCase.m
//  Magi
//
//  Created by Jamie Hardt on 7/4/12.
//  Copyright (c) 2012 Jamie Hardt. All rights reserved.
//

#import "ABOAssetSampleEnumerator_testCase.h"
#import "ABOAssetSampleEnumerator.h"

@implementation ABOAssetSampleEnumerator_testCase

-(void)test1kFile {
    AVAsset *asset = [AVAsset assetWithURL:[[NSBundle bundleForClass:[self class]] URLForResource:@"1k Tone" withExtension:@"wav"]];
    
    
    AVAssetTrack *track = [[asset tracksWithMediaType:AVMediaTypeAudio] lastObject];
    
    STAssertNotNil(track,@"failed to find audio track, test invalid");
    
    ABOAssetSampleEnumerator *enumerator = [[ABOAssetSampleEnumerator alloc]
                                            initWithAsset:asset track:track];
    
    NSUInteger __block totalSamples = 0;
    [enumerator enumerateSamplesWithBlock:^(CMSampleBufferRef buffer){
        
        STAssertFalse(buffer == NULL ,@"enumerator passed a NULL buffer");        
        totalSamples += CMSampleBufferGetNumSamples(buffer);
    
    }
                             errorHandler:^(NSError *error) {
                                 STAssertTrue(FALSE,
                                              @"error handler was called inappropriately");
                             }
     
                            finishHandler:^(AVAssetReaderStatus status) {
                                STAssertEquals((AVAssetReaderStatus)AVAssetReaderStatusCompleted,status, @"finish handler finished with the wrong status");
                            }];
    
    STAssertTrue(totalSamples == 240000, @"failed to enumerate all samples");
}

@end
