//
//  ABOIntegration_PhaseVocoder.m
//  Magi
//
//  Created by Jamie Hardt on 7/4/12.
//  Copyright (c) 2012 Jamie Hardt. All rights reserved.
//

#import "ABOIntegration_PhaseVocoder.h"
#import "ABOTestSignalGenerator.h"
#import "ABOSampleVector.h"
#import "ABOComplexVector.h"
#import <aubio/aubio.h>

@implementation ABOIntegration_PhaseVocoder

-(void)testPhaseVocoder {
    ABOTestSignalGenerator *tsg = [ABOTestSignalGenerator testGenerator];
    
    ABOSampleVector *sine = [tsg createTestSignalWithPeriods:1000 samplesPerPeriod:48];
    
    ABOComplexVector *fft = [[ABOComplexVector alloc] 
                             initWithLength:1024 channelCount:1];
    
    aubio_pvoc_t *vocoder = new_aubio_pvoc(1024, 512, 
                                           [sine channelCount]);
    
    aubio_pvoc_do(vocoder, [sine FVec] , [fft CVec]);
    
    del_aubio_pvoc(vocoder);
}

@end
