//
//  ABOOnsetDetector_testCase.m
//  Magi
//
//  Created by Jamie Hardt on 7/11/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ABOOnsetDetector_testCase.h"
#import <AVFoundation/AVFoundation.h>

#import "ABOOnsetDetector.h"

@implementation ABOOnsetDetector_testCase

-(void)testMonoFile {
    AVAsset *asset = [AVAsset assetWithURL:[[NSBundle bundleForClass:[self class]] URLForResource:@"Onset Tones Mono" 
                                                                                withExtension:@"wav"]];
    
    ABOOnsetDetector *test = [[ABOOnsetDetector  alloc] initWithAsset:asset 
                                                                track:[[asset tracksWithMediaType:AVMediaTypeAudio] lastObject]];
    
    STAssertNotNil(test,@"ABOOnsetDetector failed to init");
    
    NSArray *result = [test onsetsOfType:aubio_onset_kl onChannel:0 withPeakThreshold:1.0];
    
    STAssertNotNil(result,@"ABOOnsetDetector failed to return a result");
    
    NSMutableArray *expectedMutable = [NSMutableArray arrayWithObjects:
                         [NSValue valueWithCMTime:CMTimeMake(48000 * 1, 48000)],
                         [NSValue valueWithCMTime:CMTimeMake(48000 * 2, 48000)],
                         [NSValue valueWithCMTime:CMTimeMake(48000 * 4, 48000)],
                         [NSValue valueWithCMTime:CMTimeMake(48000 * 5, 48000)],
                         [NSValue valueWithCMTime:CMTimeMake(48000 * 7, 48000)],
                         [NSValue valueWithCMTime:CMTimeMake(48000 * 8, 48000)],nil];
    
    //NSArray *expected = [NSArray arrayWithArray:expectedMutable];
    NSMutableArray *resultMutable = [NSMutableArray arrayWithArray:result];
    
    CMTime tolerance = CMTimeMake(48000 * 0.1, 48000);
    for (NSValue *aTime in result) {
        int i;
        for (i = 0; i < [expectedMutable count]; i++) {
            CMTime anExpectedTime = [[expectedMutable objectAtIndex:i] CMTimeValue];
            CMTime diff = CMTimeSubtract(anExpectedTime, [aTime CMTimeValue]);
            if (CMTimeCompare(diff, tolerance ) == -1 /* is less than */) {
                [expectedMutable removeObjectAtIndex:i];
                [resultMutable removeObject:aTime];
                break;
            }
        }
    }
    
    
    for (NSValue *exVal in expectedMutable) {
        STAssertNil(exVal,@"failed to find onset at time %u/%u",[exVal CMTimeValue].value,[exVal CMTimeValue].timescale);
    }
    
  //  if ([resultMutable count] > 1) {
        // found more than one extra onset
        for (NSValue *resultVal in resultMutable) {
            STAssertNil(resultVal,@"found an extra onset at time %u/%u",[resultVal CMTimeValue].value,[resultVal CMTimeValue].timescale);
        }
    //}
    

    
//    STAssertEquals([result count], [expected count], 
//                   @"found the wrong number of onsets, was %u, should have been %u",[result count],[expected count]);
    

//    
//    for (NSValue *aTime in result) {
//        CMTime aTimeValue = [aTime CMTimeValue];
//        
//        for (NSValue *exVal in expectedStatic) {
//            CMTime diff = CMTimeSubtract([exVal CMTimeValue], aTimeValue);
//            if (CMTimeCompare(diff, tolerance) == -1) {
//                [expected removeObject:exVal];
//                [resultMutable removeObject:aTime];
//            }
//        }
//    }
//    STAssertEquals([expected count],(NSUInteger)0,@"not all values were found");
//    for (NSValue *leftVal in expected) {
//        STAssertNil(leftVal,@"timeval at sample %u was not found",[leftVal CMTimeValue].value);
//    }
//
//    for (NSValue *leftVal in resultMutable) {
//        STAssertNil(leftVal,@"extra timeval at sample %u was found",[leftVal CMTimeValue].value);
//    }
    
}

@end
