//
//  ABOTestSignalGenerator_testCase.m
//  Magi
//
//  Created by Jamie Hardt on 4/29/12.
//  Copyright (c) 2012 Jamie Hardt. All rights reserved.
//

#import "ABOTestSignalGenerator_testCase.h"

@implementation ABOTestSignalGenerator_testCase

-(void)testSingleton {
    ABOTestSignalGenerator *t = [ABOTestSignalGenerator testGenerator];
    
    ABOTestSignalGenerator *t2 = [ABOTestSignalGenerator testGenerator];
    
    STAssertEqualObjects(t, t2, @"singleton not created");
}

-(void)testGenerateSine {
    ABOTestSignalGenerator *t = [ABOTestSignalGenerator testGenerator];
    
    t.peakGain = 0.75f;
    
    ABOSampleVector *retVec = nil;
    
    STAssertNoThrow(
                    retVec = [t createTestSignalWithPeriods:10 samplesPerPeriod:480],@"createTestSignalWithPeriods threw an exception");
    
    STAssertEquals(retVec.channelCount, (uint_t)1,@"incorrect number of channels created");
    
    STAssertEquals(retVec.length, (uint_t)4800, @"incorrect sample length generated");
    
    NSUInteger i;
    for (i = 0; i < 4800; i++) {
        smpl_t thisSample = [retVec sampleAtFrame:i inChannel:0];
        if (i % 480 == 0) {
            
            STAssertEqualsWithAccuracy(thisSample, 0.0f,
                                       0.000001f,
                           @"Sine wave not crossing zero at beginning of period");
        }

        if (i % 480 == 240) {
            
            STAssertEqualsWithAccuracy(thisSample, 0.0f,
                                       0.000001f,
                                       @"Sine wave not at zero at 1/2 of period");
        }

        
        if (i % 480 == 120) {
            STAssertEqualsWithAccuracy(thisSample, 0.75f, 
                                       0.0000001f,
                                       @"Sine wave not at peak gain at 1/4 of period");
        }
        
        if (i % 480 == 60) {
            STAssertEqualsWithAccuracy(thisSample, 
                                       0.70710678f * 0.75f,
                                       0.0000001f,
                                       @"Sine wave not at correct level at pi/8 radians");
        }
    }
    
    
}

@end
